class Panel::Announcement::BackEnd::BulletinsController < OrbitBackendController
  
  before_filter :authenticate_user!
#  before_filter :for_admin_only,:only => [:]
#  before_filter :for_app_manager,:only => [:index,:show,] 
  before_filter :for_app_sub_manager,:except => [:index,:show,:get_sorted_and_filtered_bulletins]
  def index
    # @bulletins = Bulletin.all
    # @bulletins = Bulletin.desc("postdate desc")
	  get_categorys(params[:bulletin_category_id])
	  get_tags

    @filter = params[:filter]
    new_filter = params[:new_filter]

    if @filter && params[:clear]
      @filter.delete(params[:type])
    elsif @filter && new_filter
      if @filter.has_key?(new_filter[:type]) && @filter[new_filter[:type]].include?(new_filter[:id].to_s)
        @filter[new_filter[:type]].delete(new_filter[:id].to_s)
      elsif @filter.has_key?(new_filter[:type])
        @filter[new_filter[:type]] << new_filter[:id].to_s
      else
        @filter.merge!({new_filter[:type] => [new_filter[:id].to_s]})
      end
    elsif new_filter
      @filter = {new_filter[:type] => [new_filter[:id].to_s]}
    end

    # @bulletins = Bulletin.where("bulletin_category_id" => params[:bulletin_category_id]).desc("postdate") if params[:bulletin_category_id]
    
  	# @bulletins = Bulletin.search(params[:search], params[:category_id])
    # @bulletins = Bulletin.all.order_by([params[:sort], params[:direction]])


    # @bulletins = (params[:sort] || @filter) ? get_sorted_and_filtered_bulletins : Bulletin.all.page(params[:page]).per(10)
    @bulletins = (params[:sort] || @filter) ? get_sorted_and_filtered("bulletin") : get_viewable("bulletin")
  	@bulletin_categories = BulletinCategory.all

    @bulletin_link = BulletinLink.new
    @link_url = panel_announcement_back_end_bulletins_path
	
    @bulletin_file = BulletinFile.new
    @file_url = panel_announcement_back_end_bulletins_path
    
    respond_to do |format|
      format.html # index.html.erb
      format.js { }
      format.xml  { render :xml => @bulletins }
    end
  end

  # GET /bulletins/1
  # GET /bulletins/1.xml
  def show
    @bulletin = Bulletin.find(params[:id])
	get_tags
	# get_categorys
	
    # @bulletin_categorys = BulletinCategory.where("_id" => params[:id])
	
    # if params[:id]
      # @bulletins = Bulletin.where("bulletin_category_id" => params[:id])
    # else
      # @bulletins = Bulletin.desc("postdate desc")
    # end

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @bulletin }
    end
  end

  # GET /bulletins/new
  # GET /bulletins/new.xml
  def new
    @bulletin = Bulletin.new
	
	@link_url = panel_announcement_back_end_bulletins_path
    
	# @bulletin.bulletin_files.build
	# @bulletin.bulletin_files.new

	if get_categorys.empty?
	  flash[:alert] = t("announcement.error.no_avilb_cate_for_posting")
    redirect_to :action => :index
  else
	  get_tags
      respond_to do |format|
        format.html # new.html.erb
        format.xml  { render :xml => @bulletin }
      end
  	end
  end

  # GET /bulletins/1/edit
  def edit
    @bulletin = Bulletin.find(params[:id])
    if !current_user.admin? && (@bulletin.is_rejected? || @bulletin.is_checked?)
      redirect_to :action => :index
    else
      # @summary_variable = @bulletin.summary_variable
  	
    	@link_url = panel_announcement_back_end_bulletin_path(@bulletin)
    	
    	get_categorys
    	get_tags
    end
  end

  # POST /bulletins
  # POST /bulletins.xml
  def create
	
	if params[:bulletin_link]
  
		@bulletin_link = BulletinLink.new(params[:bulletin_link])

		respond_to do |format|
		  if @bulletin_link.save
			format.js { render 'create_bulletin_link' }
		  end
		end
	
	elsif params[:bulletin_file]
  
		@bulletin_file = BulletinFile.new(params[:bulletin_file])

		respond_to do |format|
		  if @bulletin_file.save
			format.js { render 'create_bulletin_file' }
		  end
		end
	
	else  
  
		@bulletin = Bulletin.new(params[:bulletin])
    @bulletin.deadline = nil if (@bulletin.deadline < @bulletin.postdate rescue nil)
		
		@bulletin.create_user_id = current_user.id
		@bulletin.update_user_id = current_user.id

		respond_to do |format|
		  if @bulletin.save
			# format.html { redirect_to(panel_announcement_back_end_bulletin_url(@bulletin), :notice => t('announcement.create_bulletin_success')) }
			format.html { redirect_to(panel_announcement_back_end_bulletins_url, :notice => t('announcement.create_bulletin_success')) }
			format.xml  { render :xml => @bulletin, :status => :created, :location => @bulletin }
			format.js
		  else
			format.html { render :action => "new" }
			format.xml  { render :xml => @bulletin.errors, :status => :unprocessable_entity }
		  end
		end
		
	end
	
  end

  def link_quick_add
	# debugger
    
    @bulletin_link = BulletinLink.new
	@link_url = panel_announcement_back_end_bulletins_path
	
	@bulletin_link.bulletin_id = params[:bulletin_id]
	
    respond_to do |format|
      format.js
    end
	
  end

  def link_quick_edit
	# debugger
    @bulletin_link = BulletinLink.find(params[:bulletin_id])
	
	@link_url = panel_announcement_back_end_bulletin_path(@bulletin_link)
	
    # @bulletin = Bulletin.find(params[:bulletin_id])
	
	# @link_url = panel_announcement_back_end_bulletin_path(@bulletin)
	
    respond_to do |format|
      format.js
    end
	
  end

  def file_quick_add
    # debugger
    
    @bulletin_file = BulletinFile.new
    @file_url = panel_announcement_back_end_bulletins_path
	
    @bulletin_file.bulletin_id = params[:bulletin_id]
	
    respond_to do |format|
      format.js
    end
	
  end

  def file_quick_edit
    # debugger
    @bulletin_file = BulletinFile.find(params[:bulletin_id])
	
    @file_url = panel_announcement_back_end_bulletin_path(@bulletin_file)
	
    respond_to do |format|
      format.js
    end
  end

  # PUT /bulletins/1
  # PUT /bulletins/1.xml
  def update
	
  	if params[:bulletin_link]
  	
  		@bulletin_link = BulletinLink.find(params[:id])
  		
  		@link_url = panel_announcement_back_end_bulletin_path(@bulletin_link)

  		respond_to do |format|
  		  if @bulletin_link.update_attributes(params[:bulletin_link])
  			# format.html { redirect_to(panel_announcement_back_end_bulletins_url) }
  			format.js { render 'update_bulletin_link' }
  		  end
  		end
  	
  	elsif params[:bulletin_file]
  	
  		@bulletin_file = BulletinFile.find(params[:id])
  		
  		@file_url = panel_announcement_back_end_bulletin_path(@bulletin_file)

  		respond_to do |format|
  		  if @bulletin_file.update_attributes(params[:bulletin_file])
  			# format.html { redirect_to(panel_announcement_back_end_bulletins_url) }
  			format.js { render 'update_bulletin_file' }
  		  end
  		end
  	
  	else
    
  		@bulletin = Bulletin.find(params[:id])
      @bulletin.deadline = nil if (@bulletin.deadline < @bulletin.postdate rescue nil)
  		
  		@bulletin.update_user_id = current_user.id
  		
  		# @bulletin.image.clear if params[:bulletin][:image_del] == '1'
  		# if params[:bulletin][:image_del] == '1' 
  			# @bulletin.remove_image!
  			# @bulletin.image_del = nil
  			# params[:bulletin][:image_del] = nil
  		# end

  		respond_to do |format|
  		  if @bulletin.update_attributes(params[:bulletin])
  			# format.html { redirect_to(panel_announcement_back_end_bulletin_url(@bulletin), :notice => t('bulletin.update_bulletin_success')) }
  			format.html { redirect_to(panel_announcement_back_end_bulletins_url, :notice => t('bulletin.update_bulletin_success')) }
  			format.js  { render 'toggle_enable' }
  			format.xml  { head :ok }
  		  else
          get_tags
          get_categorys
  			format.html { render :action => "edit" }
  			format.xml  { render :xml => @bulletin.errors, :status => :unprocessable_entity }
  		  end
  		end
		
    end
	
  end

  # DELETE /bulletins/1
  # DELETE /bulletins/1.xml
  def destroy
    @bulletin = Bulletin.find(params[:id])
    # @bulletin.bulletin_files.destroy
    @bulletin.destroy

    respond_to do |format|
      format.html { redirect_to(panel_announcement_back_end_bulletins_url) }
      # format.xml  { head :ok }
      format.js
    end
  end

  # def top_edit
	
	# Bulletin.where(id: params[:id]).update_all( is_top: true )
    # respond_to do |format|
      # format.html { redirect_to(panel_announcement_back_end_bulletins_url) }
      # format.xml  { head :ok }
    # end
	
  # end
  

  def load_quick_edit
    @bulletin = Bulletin.find(params[:id])
    @type = params[:type]
    @bulletin_categories = BulletinCategory.all
    get_tags
  end

  def delete
    if params[:to_delete]
      bulletins = Bulletin.any_in(:_id => params[:to_delete]).delete_all
    end
    redirect_to panel_announcement_back_end_bulletins_url(:filter => params[:filter], :direction => params[:direction], :sort => params[:sort], :sort_options => params[:sort_options])
  end

  
  protected
  
  def get_categorys(id = nil)
    @bulletin_categorys = []
    #@unit_list_for_anc = UnitListForAnc.all
    if(is_manager? || is_admin?)
      @bulletin_categorys = (id ? BulletinCategory.find(id).to_a : BulletinCategory.excludes('disabled' => true))
    elsif is_sub_manager?
      @bulletin_categorys = BulletinCategory.authed_for_user(current_user,'submit')
    end
  end
  
  def get_tags
  	module_app = ModuleApp.first(:conditions => {:key => 'announcement'})
  	@tags = Tag.all(:conditions => {:module_app_id => module_app.id}).order_by(I18n.locale, :asc)
  end
  
end
